]> git.proxmox.com Git - mirror_ubuntu-hirsute-kernel.git/blob - scripts/link-vmlinux.sh
Merge git://git.kernel.org/pub/scm/linux/kernel/git/bpf/bpf-next
[mirror_ubuntu-hirsute-kernel.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10 # (not within --whole-archive), and do not require symbol indexes added.
11 #
12 # vmlinux
13 # ^
14 # |
15 # +--< $(KBUILD_VMLINUX_OBJS)
16 # | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17 # |
18 # +--< $(KBUILD_VMLINUX_LIBS)
19 # | +--< lib/lib.a + more
20 # |
21 # +-< ${kallsymso} (see description in KALLSYMS section)
22 #
23 # vmlinux version (uname -v) cannot be updated during normal
24 # descending-into-subdirs phase since we do not yet know if we need to
25 # update vmlinux.
26 # Therefore this step is delayed until just before final link of vmlinux.
27 #
28 # System.map is generated to document addresses of all kernel symbols
29
30 # Error out on error
31 set -e
32
33 # Nice output in kbuild format
34 # Will be supressed by "make -s"
35 info()
36 {
37 if [ "${quiet}" != "silent_" ]; then
38 printf " %-7s %s\n" "${1}" "${2}"
39 fi
40 }
41
42 # Link of vmlinux.o used for section mismatch analysis
43 # ${1} output file
44 modpost_link()
45 {
46 local objects
47
48 objects="--whole-archive \
49 ${KBUILD_VMLINUX_OBJS} \
50 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
55 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 }
57
58 # Link of vmlinux
59 # ${1} - output file
60 # ${2}, ${3}, ... - optional extra .o files
61 vmlinux_link()
62 {
63 local lds="${objtree}/${KBUILD_LDS}"
64 local output=${1}
65 local objects
66
67 info LD ${output}
68
69 # skip output file argument
70 shift
71
72 if [ "${SRCARCH}" != "um" ]; then
73 objects="--whole-archive \
74 ${KBUILD_VMLINUX_OBJS} \
75 --no-whole-archive \
76 --start-group \
77 ${KBUILD_VMLINUX_LIBS} \
78 --end-group \
79 ${@}"
80
81 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
82 -o ${output} \
83 -T ${lds} ${objects}
84 else
85 objects="-Wl,--whole-archive \
86 ${KBUILD_VMLINUX_OBJS} \
87 -Wl,--no-whole-archive \
88 -Wl,--start-group \
89 ${KBUILD_VMLINUX_LIBS} \
90 -Wl,--end-group \
91 ${@}"
92
93 ${CC} ${CFLAGS_vmlinux} \
94 -o ${output} \
95 -Wl,-T,${lds} \
96 ${objects} \
97 -lutil -lrt -lpthread
98 rm -f linux
99 fi
100 }
101
102 # generate .BTF typeinfo from DWARF debuginfo
103 # ${1} - vmlinux image
104 # ${2} - file to dump raw BTF data into
105 gen_btf()
106 {
107 local pahole_ver
108 local bin_arch
109
110 if ! [ -x "$(command -v ${PAHOLE})" ]; then
111 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
112 return 1
113 fi
114
115 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
116 if [ "${pahole_ver}" -lt "113" ]; then
117 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
118 return 1
119 fi
120
121 info "BTF" ${2}
122 vmlinux_link ${1}
123 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
124
125 # dump .BTF section into raw binary file to link with final vmlinux
126 bin_arch=$(LANG=C ${OBJDUMP} -f ${1} | grep architecture | \
127 cut -d, -f1 | cut -d' ' -f2)
128 bin_format=$(LANG=C ${OBJDUMP} -f ${1} | grep 'file format' | \
129 awk '{print $4}')
130 ${OBJCOPY} --change-section-address .BTF=0 \
131 --set-section-flags .BTF=alloc -O binary \
132 --only-section=.BTF ${1} .btf.vmlinux.bin
133 ${OBJCOPY} -I binary -O ${bin_format} -B ${bin_arch} \
134 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
135 }
136
137 # Create ${2} .o file with all symbols from the ${1} object file
138 kallsyms()
139 {
140 info KSYM ${2}
141 local kallsymopt;
142
143 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
144 kallsymopt="${kallsymopt} --all-symbols"
145 fi
146
147 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
148 kallsymopt="${kallsymopt} --absolute-percpu"
149 fi
150
151 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
152 kallsymopt="${kallsymopt} --base-relative"
153 fi
154
155 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
156 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
157
158 local afile="`basename ${2} .o`.S"
159
160 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
161 ${CC} ${aflags} -c -o ${2} ${afile}
162 }
163
164 # Perform one step in kallsyms generation, including temporary linking of
165 # vmlinux.
166 kallsyms_step()
167 {
168 kallsymso_prev=${kallsymso}
169 kallsymso=.tmp_kallsyms${1}.o
170 kallsyms_vmlinux=.tmp_vmlinux${1}
171
172 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
173 kallsyms ${kallsyms_vmlinux} ${kallsymso}
174 }
175
176 # Create map file with all symbols from ${1}
177 # See mksymap for additional details
178 mksysmap()
179 {
180 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
181 }
182
183 sortextable()
184 {
185 ${objtree}/scripts/sortextable ${1}
186 }
187
188 # Delete output files in case of error
189 cleanup()
190 {
191 rm -f .btf.*
192 rm -f .tmp_System.map
193 rm -f .tmp_kallsyms*
194 rm -f .tmp_vmlinux*
195 rm -f System.map
196 rm -f vmlinux
197 rm -f vmlinux.o
198 }
199
200 on_exit()
201 {
202 if [ $? -ne 0 ]; then
203 cleanup
204 fi
205 }
206 trap on_exit EXIT
207
208 on_signals()
209 {
210 exit 1
211 }
212 trap on_signals HUP INT QUIT TERM
213
214 #
215 #
216 # Use "make V=1" to debug this script
217 case "${KBUILD_VERBOSE}" in
218 *1*)
219 set -x
220 ;;
221 esac
222
223 if [ "$1" = "clean" ]; then
224 cleanup
225 exit 0
226 fi
227
228 # We need access to CONFIG_ symbols
229 . include/config/auto.conf
230
231 # Update version
232 info GEN .version
233 if [ -r .version ]; then
234 VERSION=$(expr 0$(cat .version) + 1)
235 echo $VERSION > .version
236 else
237 rm -f .version
238 echo 1 > .version
239 fi;
240
241 # final build of init/
242 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
243
244 #link vmlinux.o
245 info LD vmlinux.o
246 modpost_link vmlinux.o
247
248 # modpost vmlinux.o to check for section mismatches
249 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
250
251 info MODINFO modules.builtin.modinfo
252 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
253
254 btf_vmlinux_bin_o=""
255 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
256 if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
257 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
258 else
259 echo >&2 "Failed to generate BTF for vmlinux"
260 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
261 exit 1
262 fi
263 fi
264
265 kallsymso=""
266 kallsymso_prev=""
267 kallsyms_vmlinux=""
268 if [ -n "${CONFIG_KALLSYMS}" ]; then
269
270 # kallsyms support
271 # Generate section listing all symbols and add it into vmlinux
272 # It's a three step process:
273 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
274 # but __kallsyms is empty.
275 # Running kallsyms on that gives us .tmp_kallsyms1.o with
276 # the right size
277 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
278 # the right size, but due to the added section, some
279 # addresses have shifted.
280 # From here, we generate a correct .tmp_kallsyms2.o
281 # 3) That link may have expanded the kernel image enough that
282 # more linker branch stubs / trampolines had to be added, which
283 # introduces new names, which further expands kallsyms. Do another
284 # pass if that is the case. In theory it's possible this results
285 # in even more stubs, but unlikely.
286 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
287 # other bugs.
288 # 4) The correct ${kallsymso} is linked into the final vmlinux.
289 #
290 # a) Verify that the System.map from vmlinux matches the map from
291 # ${kallsymso}.
292
293 kallsyms_step 1
294 kallsyms_step 2
295
296 # step 3
297 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
298 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
299
300 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
301 kallsyms_step 3
302 fi
303 fi
304
305 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
306
307 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
308 info SORTEX vmlinux
309 sortextable vmlinux
310 fi
311
312 info SYSMAP System.map
313 mksysmap vmlinux System.map
314
315 # step a (see comment above)
316 if [ -n "${CONFIG_KALLSYMS}" ]; then
317 mksysmap ${kallsyms_vmlinux} .tmp_System.map
318
319 if ! cmp -s System.map .tmp_System.map; then
320 echo >&2 Inconsistent kallsyms data
321 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
322 exit 1
323 fi
324 fi